typedef __UINT32_TYPE__ uint32_t;


extern uint32_t __bss_start__;
extern uint32_t __bss_end__;
extern uint32_t _etext;
extern uint32_t _sdata;
extern uint32_t _edata;
extern uint32_t __stack;


extern int main(void);

__attribute__((naked)) void Reset_Handler(void)
{
	uint32_t* i = 0;
    for (i = (uint32_t*) __bss_start__; i < (uint32_t*) __bss_end__; i++)
    {
        *i = 0;
    }

    i = (uint32_t*) _etext;
    for (uint32_t* dest = (uint32_t*) _sdata; dest < (uint32_t*) _edata; dest++)
    {
        *(uint32_t*) dest = *i;
        i++;
    }

    main();
}
